<html>
    <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <title>
        Upload Document Image
    </title>
    <meta name="viewport" content="width=device-width, initial-scale=1"/>

    <script src="https://code.jquery.com/jquery-3.4.1.js" type="text/javascript"></script>
    <script src="js-treex-view.min.js" type="text/javascript"></script>

    <link rel="stylesheet" href="css/bootstrap.css?compile=false"/>

    <link rel="stylesheet" href="https://unpkg.com/material-components-web@latest/dist/material-components-web.min.css">
    <link href="https://fonts.googleapis.com/css?family=Noto+Sans&display=swap" rel="stylesheet">
    <script src="https://unpkg.com/material-components-web@latest/dist/material-components-web.min.js"></script>
  </head>
   <body>
      <form action = "http://localhost:5000/" method = "POST"
         enctype = "multipart/form-data">
         <input type = "file" name = "file" />
         <input type = "submit"/>

<!--          <div class="input-group mb-3">-->
<!--              <div class="custom-file">-->
<!--                  <input type="file" class="custom-file-input" id="inputGroupFile02">-->
<!--                  <label class="custom-file-label" for="inputGroupFile02">Choose file</label>-->
<!--              </div>-->
<!--              <div class="input-group-append">-->
<!--                  <span class="input-group-text" id="">Upload</span>-->
<!--              </div>-->
<!--          </div>-->

<!--          <div class="mdc-layout-grid__inner">-->
<!--                <div class="mdc-layout-grid__cell mdc-layout-grid__cell&#45;&#45;span-8">-->
<!--                    <button id="load-file" class="mdc-button mdc-button&#45;&#45;raised next">-->
<!--                        <span class="mdc-button__label">-->
<!--                                Select image-->
<!--                        </span>-->
<!--                    </button>-->
<!--                </div>-->
<!--          </div>-->

<!--          <div class="mdc-layout-grid__inner">-->
<!--                <div class="mdc-layout-grid__cell mdc-layout-grid__cell&#45;&#45;span-8">-->
<!--                    <button id="submit-form" class="mdc-button mdc-button&#45;&#45;raised next">-->
<!--                        <span class="mdc-button__label">-->
<!--                                Submit-->
<!--                        </span>-->
<!--                    </button>-->
<!--                </div>-->
<!--          </div>-->

<!--          <div class="mdc-layout-grid__inner" id="loading">-->
<!--                <div class="mdc-layout-grid__cell mdc-layout-grid__cell&#45;&#45;span-10">-->
<!--                    <h3 class="mdc-typography&#45;&#45;subtitle2" id="process-state">&nbsp;</h3>-->
<!--                    <div role="progressbar" class="mdc-linear-progress mdc-linear-progress&#45;&#45;closed" id="submitprogress" data-mdc-auto-init="MDCLinearProgress">-->
<!--                        <div class="mdc-linear-progress__buffering-dots"></div>-->
<!--                        <div class="mdc-linear-progress__buffer"></div>-->
<!--                        <div class="mdc-linear-progress__bar mdc-linear-progress__primary-bar">-->
<!--                            <span class="mdc-linear-progress__bar-inner"></span>-->
<!--                        </div>-->
<!--                        <div class="mdc-linear-progress__bar mdc-linear-progress__secondary-bar">-->
<!--                            <span class="mdc-linear-progress__bar-inner"></span>-->
<!--                        </div>-->
<!--                    </div>-->
<!--                </div>-->
<!--            </div>-->
      </form>

<script src="https://code.jquery.com/jquery-3.4.1.js"></script>
<!-- Required MDC Web JavaScript library -->
<script src="https://unpkg.com/material-components-web@latest/dist/material-components-web.min.js"></script>
<script>
$(function() {
    //start Material framwork
    mdc.autoInit();
    var this_ = this;
    this.injectedCss = false;
    var serviceInfo;

    var submitprogress = document.getElementById('submitprogress').MDCLinearProgress;
    // var source = document.getElementById('audio-player');
  // serviceInfo=JSON.parse(JSON.stringify({"StyleCss":"empty.css","ServiceUrl":"https://dev.european-language-grid.eu/dev/rest/async/processText/srv-tts-tilde-lv-woman"}));

    // Listen to messages from parent window
    window.addEventListener('message', function(e) {

         if((window.location.origin === e.origin) && e.data != ''){

             serviceInfo = JSON.parse(e.data);
            //calling function to add theme css from ELG platform
            addCssToDocument(serviceInfo.StyleCss);
        }
    });

    //posting data to TTS service
    $("#submit-form").on("click", function(e){
        $("#result").hide();
        $("#loading").show();
        $("#trial_form :input").prop("disabled", true);
        e.preventDefault();
        source.src="";
        let text = $("#text-to-speak").val();
        let url = serviceInfo.ServiceUrl;
        postData(url , text, serviceInfo.Authorization)
            .then(resp => resp.json())
            .then(data => {
                if(data.response && data.response.type == 'stored') {
                        // async response, start polling
                        submitprogress.open();
                        submitprogress.determinate = false;
                        submitprogress.progress = 0;
                        $('#process-state').text('Processing');
                        pollForResult(data.response.uri, serviceInfo.Authorization);
                    } else {
                        // sync response, handle it now
                        handleResponse(data);
                 }
            })
            .catch(error => console.error('Error:', error));
    });

    function pollForResult(pollUrl, token) {
            function doPoll() {
                $.get({
                    url: pollUrl,
                    headers: {'Authorization': token},
                    xhrFields: {withCredentials: true},
                    success: function (data, textStatus) {
                        if (data.progress) {
                            submitprogress.determinate = (data.progress.percent > 0);
                            submitprogress.progress = data.progress.percent;
                            // schedule the next poll
                            setTimeout(doPoll, 2000);
                        } else {
                            handleResponse(data);
                        }

                        return false;
                    },
                    error: elgCallError
                });
            }

            setTimeout(doPoll, 2000);
        }

    function postData(url = '', text, token) {
  // Default options are marked with *
        return fetch(url, {
            method: 'POST',
          //  mode: 'no-cors',
            cache: 'no-cache',
            credentials: 'same-origin', // include, *same-origin, omit
            headers: new Headers({
                'Content-Type': 'text/plain',
                'Authorization': token
            }),
            //xhrFields:{withCredentials: true},
            redirect: 'follow', // manual, *follow, error
            referrer: 'ELG', // no-referrer, *client
            body: text, // body data type must match "Content-Type" header
        }); // parses JSON response into native JavaScript objects
    }

    function elgCallError(jqXHR, textStatus, errorThrown) {
            var errors = [];
            var responseJSON = jqXHR.responseJSON;
            var msgsContainer = $('#elg-messages');
            if(responseJSON && responseJSON.hasOwnProperty("failure")) {
                errors = responseJSON.failure.errors;
                resolveErrors(errors).then(function(data) {
                    $.each(data, function(i, msg) {
                     console.log(msg);
                    });
                });
            } else {
                // this should be i18n'd too really
                console.log("Unknown error occurred</div>");
                // re-enable the button

            }
        }

    function handleResponse(data) {
        if (data.response.content) {
            const blobUrl = window.URL || window.webkitURL;
            const url = "data:audio/mp3;base64,"+data.response.content;
            const a = document.createElement('a');
            a.style.display = 'none';
            a.href = url;
            a.download = 'tts-output.mp3';
            document.body.appendChild(a);
            source.src = url;
        }
           submitprogress.close();
           //$('#process-state').text('Done');
            $("#result").show();
            $("#loading").hide();
            $("#trial_form :input").prop("disabled", false);
        }

    // function that adds theme css from ELG platform
    let addCssToDocument = function(Uri){
        if (!this_.injectedCss) {
                        // inject CSS
                        var elgCss = $('<link type="text/css" rel="stylesheet" media="screen,print">');
                        elgCss.attr('href', Uri);
                        $('head').append(elgCss);
                        this_.injectedCss = true;
                    }
    }

    window.parent.postMessage("GUI:Ready to receive config", window.location.origin);
    // A way how to send info to ELG platform.
    // $("#send-button").on("click", function(e){
    //     e.preventDefault();
    //     window.parent.postMessage("Message from iframe", '');
    // });

});


</script>
   </body>
</html>